Package org.apache.commons.codec.binary

# Class Base32InputStream

java.lang.Object
java.io.InputStream
java.io.FilterInputStream
org.apache.commons.codec.binary.BaseNCodecInputStream
org.apache.commons.codec.binary.Base32InputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class Base32InputStream extends BaseNCodecInputStream
Provides Base32 encoding and decoding in a streaming fashion (unlimited size). When encoding the default lineLength is 76 characters and the default lineEnding is CRLF, but these can be overridden by using the appropriate constructor.

The default behavior of the Base32InputStream is to DECODE, whereas the default behavior of the Base32OutputStream is to ENCODE, but this behavior can be overridden by using a different constructor.

Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).

You can set the decoding behavior when the input bytes contain leftover trailing bits that cannot be created by a valid encoding. These can be bits that are unused from the final character or entire characters. The default mode is lenient decoding.

- Lenient: Any trailing bits are composed into 8-bit bytes where possible. The remainder are discarded.
- Strict: The decoding will raise an `IllegalArgumentException` if trailing bits are not part of a valid encoding. Any unused bits from the final character must be zero. Impossible counts of entire final characters are not allowed.

When strict decoding is enabled it is expected that the decoded bytes will be re-encoded to a byte array that matches the original, i.e. no changes occur on the final character. This requires that the input bytes use the same padding and alphabet as the encoder.

Since:
  1.5
See Also:
  - RFC 4648

- ## Field Summary

  ### Fields inherited from class java.io.FilterInputStream

  `in`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Base32InputStream(InputStream inputStream)`
  Creates a Base32InputStream such that all data read is Base32-decoded from the original provided InputStream.
  `Base32InputStream(InputStream inputStream, boolean doEncode)`
  Creates a Base32InputStream such that all data read is either Base32-encoded or Base32-decoded from the original provided InputStream.
  `Base32InputStream(InputStream inputStream, boolean doEncode, int lineLength, byte[] lineSeparator)`
  Creates a Base32InputStream such that all data read is either Base32-encoded or Base32-decoded from the original provided InputStream.
  `Base32InputStream(InputStream inputStream, boolean doEncode, int lineLength, byte[] lineSeparator, CodecPolicy decodingPolicy)`
  Creates a Base32InputStream such that all data read is either Base32-encoded or Base32-decoded from the original provided InputStream.

- ## Method Summary

  ### Methods inherited from class org.apache.commons.codec.binary.BaseNCodecInputStream

  `available, isStrictDecoding, mark, markSupported, read, read, reset, skip`

  ### Methods inherited from class java.io.FilterInputStream

  `close, read`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Base32InputStream

    public Base32InputStream(InputStream inputStream)
    Creates a Base32InputStream such that all data read is Base32-decoded from the original provided InputStream.
    Parameters:
      `inputStream` - InputStream to wrap.

  - ### Base32InputStream

    public Base32InputStream(InputStream inputStream, boolean doEncode)
    Creates a Base32InputStream such that all data read is either Base32-encoded or Base32-decoded from the original provided InputStream.
    Parameters:
      `inputStream` - InputStream to wrap.
      `doEncode` - true if we should encode all data read from us, false if we should decode.

  - ### Base32InputStream

    public Base32InputStream(InputStream inputStream, boolean doEncode, int lineLength, byte[] lineSeparator)
    Creates a Base32InputStream such that all data read is either Base32-encoded or Base32-decoded from the original provided InputStream.
    Parameters:
      `inputStream` - InputStream to wrap.
      `doEncode` - true if we should encode all data read from us, false if we should decode.
      `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to the nearest multiple of 4). If lineLength <= 0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
      `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.

  - ### Base32InputStream

    public Base32InputStream(InputStream inputStream, boolean doEncode, int lineLength, byte[] lineSeparator, CodecPolicy decodingPolicy)
    Creates a Base32InputStream such that all data read is either Base32-encoded or Base32-decoded from the original provided InputStream.
    Parameters:
      `inputStream` - InputStream to wrap.
      `doEncode` - true if we should encode all data read from us, false if we should decode.
      `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to the nearest multiple of 4). If lineLength <= 0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
      `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.
      `decodingPolicy` - The decoding policy.
    Since:
      1.15